<?php

namespace ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfJP_ErrorType ArrayType
 * @subpackage Arrays
 */
class ArrayOfJP_ErrorType extends AbstractStructArrayBase
{
    /**
     * The Error
     * Meta informations extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * @var \StructType\JP_ErrorType[]
     */
    public $Error;
    /**
     * Constructor method for ArrayOfJP_ErrorType
     * @uses ArrayOfJP_ErrorType::setError()
     * @param \StructType\JP_ErrorType[] $error
     */
    public function __construct(array $error = array())
    {
        $this
            ->setError($error);
    }
    /**
     * Get Error value
     * @return \StructType\JP_ErrorType[]|null
     */
    public function getError()
    {
        return $this->Error;
    }
    /**
     * Set Error value
     * @throws \InvalidArgumentException
     * @param \StructType\JP_ErrorType[] $error
     * @return \ArrayType\ArrayOfJP_ErrorType
     */
    public function setError(array $error = array())
    {
        foreach ($error as $arrayOfJP_ErrorTypeErrorItem) {
            // validation for constraint: itemType
            if (!$arrayOfJP_ErrorTypeErrorItem instanceof \StructType\JP_ErrorType) {
                throw new \InvalidArgumentException(sprintf('The Error property can only contain items of \StructType\JP_ErrorType, "%s" given', is_object($arrayOfJP_ErrorTypeErrorItem) ? get_class($arrayOfJP_ErrorTypeErrorItem) : gettype($arrayOfJP_ErrorTypeErrorItem)), __LINE__);
            }
        }
        $this->Error = $error;
        return $this;
    }
    /**
     * Add item to Error value
     * @throws \InvalidArgumentException
     * @param \StructType\JP_ErrorType $item
     * @return \ArrayType\ArrayOfJP_ErrorType
     */
    public function addToError(\StructType\JP_ErrorType $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\JP_ErrorType) {
            throw new \InvalidArgumentException(sprintf('The Error property can only contain items of \StructType\JP_ErrorType, "%s" given', is_object($item) ? get_class($item) : gettype($item)), __LINE__);
        }
        $this->Error[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \StructType\JP_ErrorType|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \StructType\JP_ErrorType|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \StructType\JP_ErrorType|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \StructType\JP_ErrorType|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \StructType\JP_ErrorType|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string Error
     */
    public function getAttributeName()
    {
        return 'Error';
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructArrayBase::__set_state()
     * @uses AbstractStructArrayBase::__set_state()
     * @param array $array the exported values
     * @return \ArrayType\ArrayOfJP_ErrorType
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
